
	ZEROLOCALES MACRO dernierelocale
		mov eax, esp
		mov esp, ebp	; base page of calling procedure
		@@:
		push 0
		cmp esp, eax
		ja @B	
	ENDM	
	
STDERR MACRO
	call  __iob_func
	add eax,2 * sizeof (_iobuf) ; _iobuf structure #define stderr (&__iob_func()[2])
	mov sortiestd,eax
	EXITM <sortiestd>
ENDM
STDIN MACRO
	call  __iob_func
	add eax,0 * sizeof (_iobuf) ; _iobuf structure #define stdin  (&__iob_func()[0])
	mov sortiestd,eax
	EXITM <sortiestd>

ENDM
STDOUT MACRO
	call  __iob_func
	add eax,1 * sizeof (_iobuf) ; _iobuf structure #define stdout (&__iob_func()[1])
	mov sortiestd,eax
	EXITM <sortiestd>

ENDM
	
	
F MACRO retour:REQ,arg1:VARARG
	invoke arg1
	mov retour,eax
	EXITM <retour>	
ENDM
return MACRO arg1
	IFNB <arg1>
		mov eax,arg1
	ENDIF
	ret
ENDM

PuPo MACRO M1, M2
	push M2
	pop  M1
ENDM
;the array of pointer allow to pass the limit of three registers usable for the call
;arg1 dword pointer,arg2 offset in structure,offset of an array of pointer
PADR MACRO pointer_name:REQ,interne_struct:REQ,arg3:REQ
	result INSTR <pointer_name>,<.>
	ECHO result
	IF result
		result = result + 1
		indirect SUBSTR <pointer_name>,result  ;TEXTEQU @SubStr (<pointer_name>,result)
		computeoffset CATSTR <DECLARE_>,indirect,<.>,<interne_struct>	
					
	ELSE
		computeoffset CATSTR <DECLARE_>,<pointer_name>,<.>,<interne_struct>
	ENDIF
	push edx
	mov edx,pointer_name
	add edx,computeoffset         
	mov [BUFIDR+arg3],edx
	pop edx
	EXITM <dword ptr [BUFIDR+arg3]>
ENDM



PVALG MACRO pointer_name:REQ,interne_struct:REQ,arg3:REQ
	;Local result,indirect
	result INSTR <pointer_name>,<.>
	IF result
		result = result + 1
		indirect SUBSTR <pointer_name>,result  ;TEXTEQU @SubStr (<pointer_name>,result)
		computeoffset CATSTR <DECLARE_>,indirect,<.>,<interne_struct>	
					
	ELSE
		computeoffset CATSTR <DECLARE_>,<pointer_name>,<.>,<interne_struct>
	ENDIF
	push edx
	mov edx,pointer_name
	mov edx,DWORD PTR [edx+computeoffset]
	mov [BUFIDR+arg3],edx
	pop edx
	
	EXITM <dword ptr [BUFIDR+arg3]>
ENDM
PVALP MACRO pointer_name:REQ,interne_struct:REQ,value:REQ
	;Local result,indirect
	result INSTR <pointer_name>,<.>
	IF result
		result = result + 1
		indirect SUBSTR <pointer_name>,result  ;TEXTEQU @SubStr (<pointer_name>,result)
		computeoffset CATSTR <DECLARE_>,indirect,<.>,<interne_struct>	
					
	ELSE
		computeoffset CATSTR <DECLARE_>,<pointer_name>,<.>,<interne_struct>
	ENDIF
	;value peut provenir d'une structure point par un dword
	;on extrait le dword et l'offset interne a la structure
	;g_writeIO->lpo.Offset=appContext->dwWriteOffset
	;appContext = dwpointer
	;dwWriteOffset = (Stucture.)dwWriteOffset 
	resultvalue INSTR <value>,<.>
	IF resultvalue
		resultvalue = resultvalue + 1
		valueoffset SUBSTR <value>,resultvalue  ;TEXTEQU @SubStr (<pointer_name>,resultvalue)
		resultvalue = resultvalue -2
		dwpointer  SUBSTR <value>,1,resultvalue
		getstructure  CATSTR <DECLARE_>,dwpointer
					
	ENDIF	
	
	push edx
	push ebx
	IF resultvalue
		mov ebx,dwpointer
		mov edx,[ebx].getstructure.valueoffset
	ELSE
		mov edx,value
	ENDIF
	mov ebx,pointer_name
	mov [ebx+computeoffset],edx
	mov [BUFIDR+arg3],edx
	pop ebx
	pop edx	
ENDM

;add: DECLARE_pointeur TEXTEQU <STInterFace>
;where pointeur is
; pointeur dd     ;all name who get the com pointer
; USAGE:
; COM pointeur,Release  ;usefull with duplicate pointer
COM MACRO ppv:REQ,fonction:REQ,args:VARARG
	local InvokeInterface
	computeoffset CATSTR <DECLARE_>,<ppv>
	;---------- controle les arguments 
    FOR arg, <args>     ;verifier que edx n'est pas dans la liste d'arguments args
        IFIDNI <&arg>, <edx>	;
            .ERR <edx is not allowed as a coinvoke parameter>
        ENDIF
    ENDM
    IFIDNI <&pInterface>, <edx>
        .ERR <edx is not allowed as a coinvoke parameter>
    ENDIF
	;------------ fin de controle --------------------------------
	;InvokeInterface = concatene ...CATSTR(concatene) MACRO instruction MASM32	
	;---------- on doit mettre ppv en premier argument -----------------------------------
    InvokeInterface CATSTR <invoke (computeoffset ptr  [edx]).>,<&fonction,ppv>
    IFNB <args>     ; add the list of parameter arguments if any
        InvokeInterface CATSTR InvokeInterface, <, >, <&args> 
    ENDIF 
	; -- charge le pointeur ---------------------
    mov edx, ppv
    mov edx, [edx]
    InvokeInterface		
ENDM


    ; --------------------------------------------------------
    ; Cre une donne en data,renvoie l'tiquette de la chaine
    ; La cration du nom de l'tiquette est facultatif
    ; la macro vrifie la syntaxe des chaines et tiquettes
    ; ---------------------------------------------------------
      CREDATA MACRO quoted_text:REQ,NomdeChaine
		LOCAL Local_Etiquette,verif
	IFNB <NomdeChaine>			;present
		verif SUBSTR <NomdeChaine>,1,1
      		IFIDN verif,<">            ;si le premier caractere est "
			.ERR  <ETIQUETTE SUPRIMER les " >			
		ENDIF
	Local_Etiquette TEXTEQU <NomdeChaine>		;changer le nom d'tiquette
	ENDIF
	verif SUBSTR <quoted_text>,1,1				
	IFDIF verif,<">
		.ERR  <CHAINE AJOUTER LES " >
	ENDIF
	
		.data
		Local_Etiquette db quoted_text,0
		.code
		EXITM <Local_Etiquette>
      ENDM
    ; ----------------------------------------------------
    ; Sort l' adresse de la chaine crer, SADR("chaine")
    ; -----------------------------------------------------
    ; ----------------------------------------------------
    ; Sort l' adresse de la chaine crer, SADR("chaine")
    ; -----------------------------------------------------
	;si la chaine est "!DefaultToc",vite que "!" ne devienne un oprateur
	;l'espace aprs ADDR et offset est indispensable
	SADR MACRO quoted_text:REQ,NomdeChaine
           EXITM @CatStr(<ADDR >, CREDATA(quoted_text,NomdeChaine))
      ENDM
    ; ----------------------------------------------------
    ; Sort l' offset de la chaine crer, SOFF("chaine")
    ; -----------------------------------------------------
	SOFF MACRO quoted_text:REQ,NomdeChaine
        	EXITM @CatStr(<Offset >, CREDATA(quoted_text,NomdeChaine))
      ENDM	









